package GSP.data;



import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

public class MetaData {

   private List<String> uniqueItems;

   public MetaData(List<Sequence> database) 
   {
      Set<String> uniqueItems = new HashSet<>();
      for(Sequence sequence : database){
         for(int i=0; i < sequence.countElements(); ++i){
            ItemSetWithTimeId element = sequence.elementAt(i);
            uniqueItems.addAll(element.getItems());
         }
      }

      this.uniqueItems = uniqueItems.stream().collect(Collectors.toList());
   }

   public List<String> getUniqueItems() {
	   return uniqueItems;
   }

	public void setUniqueItems(List<String> uniqueItems) {
		this.uniqueItems = uniqueItems;
	}
   
   
}
