package GSP.main;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import GSP.data.MetaData;
import GSP.data.Sequence;
import GSP.data.Sequences;


public class GSPFrequentSequenceGenerator 
{
	private String outputPath = null;
	private int minSupportLevel = 0;
	
	
	public GSPFrequentSequenceGenerator(int minSupportLevel, String outputPath) throws IOException {
		this.minSupportLevel = minSupportLevel;
		this.outputPath = outputPath;
	}
	
   public void runGSPAlgorithm(List<Sequence> database) throws IOException
   { 
	   	BufferedWriter writer = new BufferedWriter(new FileWriter(outputPath, true));
			   	
	   	GSP method = new GSP(outputPath);
		
	   	method.setMinSupportLevel(minSupportLevel);
		List<String> uniqueItems = new MetaData(database).getUniqueItems();
		Sequences result = method.minePatterns(database, uniqueItems, -1);

		result.getSequences().stream().forEach(sequence -> {
			// Frequent sequence are generated here
			try {
				writer.write("sequence: " + sequence);
				writer.newLine();
				//System.out.println("sequence: " + sequence);
			} catch (IOException e) {
				e.printStackTrace();
			}
			// System.out.println("sequence: " + sequence);
			
		});
		writer.close();
   }
}
