package GSP.main;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import GSP.data.Sequence;

/*The GSP module (run using this class GSPMainRunner) takes in the output of the SHOD module*/
public class GSPMainRunner 
{
	private String inputPath;
	private String outputPath;
	private int minSupportLevel;
	private int numOfLines;
	
	//default constructor
	public GSPMainRunner() {
		inputPath = null;
		outputPath = null;
		minSupportLevel = 0;
		numOfLines = 0;
	}
	
	//initializing constructor 
	public GSPMainRunner(String inputPath, String outputPath, int minSupportLevel, int numOfLines){
		
		this.inputPath = inputPath;
		this.outputPath = outputPath;
		this.minSupportLevel = minSupportLevel;
		this.numOfLines = numOfLines;
		
	}
	
	public void execute() {

		List<Sequence> database = new ArrayList<>();
		BufferedReader myInput = null;
		String thisLine; // variable to read a line
		
		 try {    
			 	FileInputStream fin = new FileInputStream(new File(inputPath));
				myInput = new BufferedReader(new InputStreamReader(fin));
				
				//
				int counter = 0;
				while ((thisLine = myInput.readLine()) != null)
				{
					if(counter == numOfLines) {
						break;
					}
					String product1=thisLine.substring(0, thisLine.lastIndexOf(","));	
					database.add(Sequence.make(product1));
					counter++;
				}
				
				GSPFrequentSequenceGenerator gsp=new GSPFrequentSequenceGenerator(minSupportLevel,outputPath);
				gsp.runGSPAlgorithm(database);
				myInput.close(); 	
				
	    } catch (IOException e) {
	        e.printStackTrace();
	    } 
		
	}

}
