package SHOD;

import java.io.BufferedWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

public class DailySequentialDatabase {
	
	private HashMap<String, String> indicatorSessionIDMap = new HashMap<>();
	private HashMap<String,String> indicatorProdutID = new HashMap<>();
	private HashMap<Date, Date> indicatorDate = new HashMap<>();

	private List<Object> timeList = new ArrayList<>();
	private Date intermediateDate;
	
	/* we added the flag so the output file doesn't have an empty newline 
	at the beginning because this causes an error when running StrictMultisequenceHSP.java
	the newline is written because the if statement is never true at the beginning since the session doesn't exist and 
	indicatorSessionIDMap will always be empty at the beginning
	 * */
	private boolean flag = true;
	
	public int formulateDailyDB(String userId, String productID, Date timeStamp, BufferedWriter out) {
	
	   try {
		   if(indicatorSessionIDMap.containsKey(userId)) {
		      
			   flag=false;
			   
			   //System.out.println("same session ");
	
			   long timeDef=timeStamp.getTime()-indicatorDate.get(intermediateDate).getTime();
			  
			   DecimalFormat sequenceFormatter = new DecimalFormat("###,###"); 
			   
			   int diffDays = (int) (timeDef / (24 * 60 * 60 * 1000));
			    
			   //System.out.println("Days difference==="+diffDays);
				  
			   indicatorDate.put(intermediateDate, timeStamp);
				
			   if(diffDays >= 1) {		
					out.write("-1"+"\t");
					out.write(productID+"\t");
			   } else {
					out.write(productID+"\t");
			   }
		   } else {
		      
			   indicatorSessionIDMap.put(userId, userId);
			   indicatorDate.put(intermediateDate,timeStamp);
			   if(flag == false)
				   out.write("\n");
			   out.write(productID+"\t");
			   //System.out.println("Not same session ");
		   } 
	   } catch(Exception e) {
		   e.printStackTrace();
	   }
	   
	   return 0;
	}
	
	public void advancedObjectSave(String userId,String productID,Date timeStamp,BufferedWriter out) {
		
		List <Object> str=new ArrayList<>();
		try {
			 if(indicatorSessionIDMap.containsKey(userId)) {  
				  out.write(productID);
				  out.write("\t");
			 } else {
				 str.clear();
				 indicatorSessionIDMap.put(userId, userId);
				 str.add(productID);
				 out.write("\n");
				 out.write(productID+"\t");
				 
			 }
		} catch(Exception e) {
			e.printStackTrace();
		}
		
	}
}
