package SHOD;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.ParseException;
import java.util.Scanner;

/* The SHOD module (run using this class SequenceDBMain) starts the HSPRec19 program using the raw data provided. In our case, the "ClickData" and "PurchaseData" */
public class SequenceDBMain {

	private BufferedWriter out;
	private File file;
	

	public SequenceDBMain(String inputPath, String outputPath) throws Exception{
		file  = new File(inputPath);
		out = new BufferedWriter(new FileWriter(outputPath));
	}

    public void generateIntermediateDB() throws RuntimeException, ParseException
    {
    	
    	TimeFormatter amazonTimeConverter=new TimeFormatter();
    	
    	DailySequentialDatabase sb=new DailySequentialDatabase();
    
    	
        try {    
        	Scanner scnr = new Scanner(file);
	 
	    	while(scnr.hasNextLine())
	    	{ 
	    	   String line = scnr.nextLine();  
	    	   String[] clickArray = line.split("\t");   
	    	   //System.out.println(line);
	    	   // if clickArray[3] has numbers less than 7 continue. That means that the day in the date is missing from the input file
	    	   int checkDate = (clickArray[3].replaceAll("[^\\d]", "" )).length();
	    	   if(checkDate < 7) {
	    		   continue;
	    	   }
	    	   sb.formulateDailyDB(clickArray[0], clickArray[1],amazonTimeConverter.dateFormatter(clickArray[3]),out);
	    	 
	    	}
	    	out.close();
	    	scnr.close();
	    	
	    	 	   	
        } catch (IOException e) {
        	e.printStackTrace();
        } 
        
    }
}
