package SHOD;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;
import java.util.stream.Collectors;

public class UsersThatClickedAndPurchasedGenerator{
	String inputPath1;
	String inputPath2;
	String outputPath;
	
	public UsersThatClickedAndPurchasedGenerator(){
		inputPath1 = null;
		inputPath2 = null;
		outputPath = null;
	}
	
	public UsersThatClickedAndPurchasedGenerator(String inputPath1, String inputPath2, String outputPath){
		this.inputPath1 = inputPath1;
		this.inputPath2 = inputPath2;
		this.outputPath = outputPath;
	}


	private void getUsersThatClickedAndPurchased(Scanner sc, Set<String> usersThatPurchased) {
		BufferedWriter bw;
		try {
			bw = new BufferedWriter(new FileWriter(outputPath));
			while(sc.hasNextLine()) {
				String line = sc.nextLine();
				String[] array = line.split("\t"); 
				if(usersThatPurchased.contains(array[0]))
					bw.write(line+"\n");
					
			}
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private Set<String> readUsers(Scanner sc){
		Set<String> users = new TreeSet<>();
		while(sc.hasNextLine()) {
			String[] line = sc.nextLine().split("\t");
			users.add(line[0]);
		}
		return users;
	} 
	
	public void execute() {
		try {
			Scanner sc = new Scanner(new BufferedReader(new FileReader(inputPath2)));
			Set<String> usersThatPurchased = readUsers(sc);
			sc.close();
			sc = new Scanner(new BufferedReader(new FileReader(inputPath1)));
			getUsersThatClickedAndPurchased(sc, usersThatPurchased);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
}